100 rem + ************************************************************************ +
102 rem *<                 Create new, fresh, FileInfo2 database                  >*
104 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
106 rem *    Append the data as DATA statements to the end of this file and RUN    *
108 rem *                                                                          *
110 rem * Creating the data from scratch is most onerous! This script is           *
112 rem * complementary to GetDBarr (- Get (FI2) database into arrays). The        *
114 rem * idea is to extract an existing FI2 database, make the modifications      *
116 rem * you need (eg text translations, relocate files or parameters (eg if      *
118 rem * you are switching to a different platform) etc). The extension names     *
120 rem * can be sorted in GetDBarr, if desired, and then reloaded into            *
122 rem * FileInfo2.                                                               *
124 rem *                                                                          *
126 rem * The new file is saved to ram1_ (unless you change the code). Copy it     *
128 rem * from there to the proper location (ie were your boot file loads FI2      *
130 rem * from) - or get FI2Config to do it for you.                               *
132 rem *                                                                          *
134 rem *    Make sure you make a backup of the original before overwriting it!    *
136 rem *                                                                          *
138 rem + ------------------------------------------------------------------------ +
140 rem * V0.01, pjw, 2021 Dec 17                                                  *
142 rem + ************************************************************************ +
144 :
146 fnm_fi2$ = 'ram1_FileInfo2_bin':        rem Output file name
148 :
150 id$ = 'FIv3'
152 adr = FI2_MAKE(Id$)
154 Old_data = FI2_DATA(adr):               rem Make dummy first entry
156 er = fi2_link(adr): ert er
158 :
160 restore
162 i% = 0
164 rep main
166  if eof: exit main
168  i% = i% + 1
170  read Extension$, Type, Flags, Action$, Jobname$, Thing$, File$, Command$
172  if Extension$ <> '': Ext$ = Extension$
174  if Extension$ = '' then
176   adr = FI2_MAKE(Id$, Type, Flags, Action$, Jobname$, Thing$, File$, Command$)
178   ert adr
180   ert FI2_LINK(Ext$, adr):              rem link in action blockelse
182  else
184   adr = FI2_MAKE(Id$, Extension$, Type, Flags, Action$, Jobname$, Thing$, File$, Command$)
186   ert adr
188   ert FI2_LINK(adr):                    rem link in action block
190  endif
192 endrep main
194 :
196 rem Ende
198 ch = fop_over(fnm_fi2$)
200 FI2_SAVE #ch, 0:                        rem Save database and FI2 extensions
202 close#ch
204 beep 2000, 2
206 :
208 :
210 rem     Merge data here..
